Skip Menu |
 

This queue is for tickets about the IO-Socket-SSL CPAN distribution.

Report information
The Basics
Id: 128716
Status: resolved
Priority: 0/
Queue: IO-Socket-SSL

People
Owner: Steffen_Ullrich [...] genua.de
Requestors: scott [...] mailblock.net
Cc:
AdminCc:

Bug Information
Severity: Important
Broken in:
  • 2.062
  • 2.063
  • 2.064
Fixed in: 2.066



Subject: Will not build on Alpine Linux 3.9.0
Download (untitled) / with headers
text/plain 1.3k
Using Alpine Linux 3.9.0 in a Docker container. Steps to reproduce: apk update && apk upgrade && apk add curl tar make gcc build-base wget gnupg perl perl-dev libressl libressl-dev zlib-dev curl -L https://cpanmin.us | perl - App::cpanminus cpanm https://cpan.metacpan.org/authors/id/S/SU/SULLR/IO-Socket-SSL-2.061.tar.gz (this works fine) cpanm https://cpan.metacpan.org/authors/id/S/SU/SULLR/IO-Socket-SSL-2.062.tar.gz (this breaks, as do 2.063 and 2.064) The error is: Show quoted text
> Failed test 'Can't locate auto/Net/SSLeay/CTX_get0_pa.al in @INC (@INC contains: /root/.cpanm/work/1551758559.877/IO-Socket-SSL-2.062/blib/lib /root/.cpanm/work/1551758559.877/IO-Socket-SSL-2.062/blib/arch /usr/local/lib/perl5/site_perl /usr/local/share/perl5/site_perl /usr/lib/perl5/vendor_perl /usr/share/perl5/vendor_perl /usr/lib/perl5/core_perl /usr/share/perl5/core_perl .) at /root/.cpanm/work/1551758559.877/IO-Socket-SSL-2.062/blib/lib/IO/Socket/SSL.pm line 122.
Seems to be caused by this patch: + + if (my $c = eval { Net::SSLeay::X509_V_FLAG_PARTIAL_CHAIN() }) { + $check_partial_chain = sub { + my $ctx = shift; + my $param = Net::SSLeay::CTX_get0_param($ctx); + Net::SSLeay::X509_VERIFY_PARAM_set_flags($param, $c); + }; + } } The file `CTX_get0_pa.al` does not exist anywhere on the host.
Download (untitled) / with headers
text/plain 613b
Am Mo 04. Mär 2019, 23:11:27, SCOTTW schrieb: Show quoted text
> Using Alpine Linux 3.9.0 in a Docker container. Steps to reproduce:
I'm not familiar what software is running in this system. Please provide the exact versions of Net::SSLeay and openssl/libressl so that I can narrow down the cause of the problem. You can do this with the following code: use strict; use warnings; use Net::SSLeay; printf("openssl version compiled=0x%0x linked=0x%0x -- %s\n", Net::SSLeay::OPENSSL_VERSION_NUMBER(), Net::SSLeay::SSLeay(), Net::SSLeay::SSLeay_version(0)); printf("Net::SSLeay version=%s\n", $Net::SSLeay::VERSION);
Download (untitled) / with headers
text/plain 378b
On Tue Mar 05 00:27:07 2019, SULLR wrote: Show quoted text
> printf("openssl version compiled=0x%0x linked=0x%0x -- %s\n", > Net::SSLeay::OPENSSL_VERSION_NUMBER(), > Net::SSLeay::SSLeay(), > Net::SSLeay::SSLeay_version(0)); > printf("Net::SSLeay version=%s\n", $Net::SSLeay::VERSION);
openssl version compiled=0x20000000 linked=0x20000000 -- LibreSSL 2.7.4 Net::SSLeay version=1.85
Download (untitled) / with headers
text/plain 510b
Am Di 05. Mär 2019, 12:56:50, SCOTTW schrieb: Show quoted text
> On Tue Mar 05 00:27:07 2019, SULLR wrote:
> > printf("openssl version compiled=0x%0x linked=0x%0x -- %s\n", > > Net::SSLeay::OPENSSL_VERSION_NUMBER(), > > Net::SSLeay::SSLeay(), > > Net::SSLeay::SSLeay_version(0)); > > printf("Net::SSLeay version=%s\n", $Net::SSLeay::VERSION);
> > openssl version compiled=0x20000000 linked=0x20000000 -- LibreSSL 2.7.4 > Net::SSLeay version=1.85
Thanks, this should be fixed in the just released version 2.065.
Download (untitled) / with headers
text/plain 567b
On Tue Mar 05 13:51:50 2019, SULLR wrote: Show quoted text
> Thanks, > this should be fixed in the just released version 2.065.
Looks like `t/verify_partial_chain.t` still uses the old check: ``` if (!eval { Net::SSLeay::X509_V_FLAG_PARTIAL_CHAIN() }) { print "1..0 # no support for X509_V_FLAG_PARTIAL_CHAIN\n"; exit(0); } ``` so that test fails: ``` # prove -lv t/verify_partial_chain.t t/verify_partial_chain.t .. 1..3 ok #Server Initialization not ok #client ssl connect ok #skip issuer check since no client Failed 1/3 subtests (less 1 skipped subtest: 1 okay) ```
Download (untitled) / with headers
text/plain 115b
Show quoted text
> Looks like `t/verify_partial_chain.t` still uses the old check:
Oops. It should be properly fixed in 2.066 now.
Download (untitled) / with headers
text/plain 211b
On Wed Mar 06 01:58:59 2019, SULLR wrote: Show quoted text
>
> > Looks like `t/verify_partial_chain.t` still uses the old check:
> > Oops. It should be properly fixed in 2.066 now.
Confirmed: fixed in 2.066. Thank you! Scott


This service is sponsored and maintained by Best Practical Solutions and runs on Perl.org infrastructure.

Please report any issues with rt.cpan.org to rt-cpan-admin@bestpractical.com.